;=====================================================
; Auteur         : DakinQuelia
; Version        : 1.0.0
; Nom de fichier : bot.mrc
;=====================================================

;=====================================================
; Script         : Variables globales
;=====================================================
var %nombot = BotIRC
var %serveurs = irc.evolu.net irc.recycled-irc.net
var %salons = #test #test2

;=====================================================
; Script         : Paramètres globaux
;=====================================================
; A la connexion
On *:CONNECT: {
  ; Le robot s'idenitfie sous le nom défini
  nick %nombot
  ; Rejoint le ou les serveur(s) défini(s)
  server -m $gettok(%serveurs,$calc($1 - 1),32)
  ; Rejoint le ou les salon(s) défini(s)
  join $gettok(%salons,$calc($1 - 1),32)
}

; Ouverture d'un message privé avec le bot
ON 1:OPEN:?: {
  msg $nick Salut $+ 4 $nick 1 $+ ! Malheureusement, je ne suis pas disponible pour répondre à votre message privé!
  halt
}

; Fermeture d'un message privé avec le bot
ON 1:CLOSE:?: {
  msg $nick Bonne journée, $+ 4 $nick 1 $+ ! 
  halt
}

; Au départ de l'utilisaeur
ON ^*:QUIT:Depart {
  $nick $address $1-
}

; Utilisation des commandes
ON *:TEXT:*:#: { 
  ; Commandes avec alias et sans permissions
  if ($1 == !op) { administrateur }
  if ($1 == !hop) { moderateur }
  if ($1 == !owner) { proprietaire }
  if ($1 == !protected) { protege }
  if ($1 == !des) { des $2 $3 }
  if ($1 == !vote) { vote $2 }
  if ($1 == !homme) { homme }
  if ($1 == !femme) { femme }
  if ($1 == !news) { nouvelles }
  if ($1 == !stat) { stats $2 }
  if ($1 == !parler) { parler $2 }
  if ($1 == !citation) { citation $2 }
  if ($1 == !sujet) { sujet $2 }
  if ($1 == !expulser) { expulser $2 $3 }
  if ($1 == !monip) { monip }
  if ($1 == !nouvelle) { nouvelle }
  if ($1 == !bannir) { bannir $2 $3 }
  if ($1 == !lechouille) { lechouilles $2 }
  if ($1 == !verrsujet) { topiclock $2 }
  if ($1 == !statcitation) { statcitation $2 }
  if ($1 == !pseudocouleur) { nickcolor }
  if ($1 == !ajoutnouvelle) { ajouternouvelle $2- }
  if ($1 == !ajoutcitation) { ajoutercitation $2- }
  if ($1 == !ignoreall) { ignoreall $2 }
  if ($1 == !reg) { regaccount $2 }
  if ($1 == !report) { botreport $$2 | halt}
  ; Commandes avec droits d'administrateur global
  if ($1 == !msg) { sendraw $$1 ::$$2 PRIVMSG $$1 :$$3 }
  if ($1 == !prive) { sendraw $$1 ::$$2 PRIVMSG $$1 :$$3 }
  ; Commandes pour faire des actions avec le bot
  if ($1 == !bsay) { botsay $2 $3- | halt }
  if ($1 == !bact) { botact $2 $3- | halt }
  ; Commandes sans alias
  if ($1 == !embrasse) { me embrasse tendrement $2 }
}

; Coloration automatique des pseudos
ON *:JOIN:#: { nickcolor # }
ON *:OP:#: { nickcolor # }
ON *:DEOP:#: { nickcolor # }
ON *:HALFOP:#: { nickcolor # }
ON *:DEHALFOP:#: { nickcolor # }
ON *:VOICE:#: { nickcolor # }
ON *:DEVOICE:#: { nickcolor # }

;=====================================================
; Script         : Gestion des niveaux
;=====================================================
; Fondateur
Alias Proprietaire {
    var %salon = #
    if ($nick isowner %salon) { mode $chan -q $nick }
	else { mode $chan +q $nick }
}

; Administrateur Protégé du salon
Alias Protege {
   var %salon = #
   if ($nick is %salon) { mode $chan -q $nick }
   else { mode $chan +q $nick }
}

; Administrateur du salon
Alias Administrateur {
   var %salon = #
   if ($nick isop %salon) { mode $chan -o $nick }
   else { mode $chan +o $nick }
}

; Modérateur du salon
Alias Moderateur {
   var %salon = #
   if ($nick ishop %salon) { mode $chan -h $nick }
   else { mode $chan +h $nick }
}

; VIP du salon
Alias VIP {
   var %salon = #
   if ($nick isvoice %salon) { mode $chan -v $nick}
   else { mode $chan +v $nick }	
}

;=====================================================
; Script         : Alias globaux
;=====================================================
; Coloriser les pseudos
Alias nickcolor {
  if ($1 == help) { echo 3 * Utilisation: "/cline <Salon> <op> <voice> <normal>" | return }
  var %cvqt = 1
  var %salon = #
  while (%cvqt <= $nick(%salon,0)) {
    if ($nick(%salon,%cvqt) isop %salon) { cline $iif($2,$2,4) %salon $nick(%salon,%cvqt) | inc %cvqt | continue }
    if ($nick(%salon,%cvqt) isvoice %salon) { cline $iif($3,$3,2) %salon $nick(%salon,%cvqt) | inc %cvqt | continue }
    if ($nick(%salon,%cvqt) ishop %salon) { cline $iif($4,$4,3) %salon $nick(%salon,%cvqt) | inc %cvqt | continue }
    ;cline $iif($4,$4,1) %salon $nick(%salon,%cvqt)
    inc %cvqt
  }
}

; Afficher son ip
Alias MonIP {
  if ($1 == help) { echo 3 * Utilisation: "/monip" | return }
  echo 3 * Votre IP: $ip
}

; Afficher les statistiques par type
Alias Stats {
   if ($1 == help) { echo 3 * Utilisation: "/stats <Type de stats>" | return }
   if ($1 == $null) { echo 2 * Paramètre insuffisant! | return }
   var %fichier = $shortfn($mircdir\datas\$1.txt)
   var %compteur = $lines(%fichier).text
   var %salon = $chan
   if ($1 == citations) { msg $salon Il y a $+ 4 %compteur $+ 1 citation(s) dans la base. }
   if ($1 == nouvelles) { msg $salon Il y a $+ 4 %compteur $+ 1 nouvelle(s) dans la base. }
}

; Eviter multiples départs dans un même temps
Alias netsplit {
   %M = $chan(0) | set %j 1
   while (%j <= %M) {
     %chan = $chan(%j)
     set %temp % $+ netsplit $+ %chan | set %temp [ [ %temp ] ]
     if (%temp != $null) { 
	   echo 2 %chan $chr(91) $+ $time $+ $chr(93) *** Netsplit - %temp -  $+ $gettok(%temp,0,32) personne(s) ( $+ %serveurs $+ ) 
	 }
     inc %j
   }
   unset %netsplit*
} 

; Afficher le message de départ en français
Alias Depart {
   if ($gettok($3,0,46) > 1 && $gettok($4,0,46) > 1) {
     set %serveurs $3 // $4
     %M = $comchan($1,0) | set %j 1
     while (%j <= %M) {
       %chan = $comchan($1,%j)
       set %temp % $+ netsplit $+ %chan | set %temp [ [ %temp ] ]
       set % $+ netsplit $+ %chan %temp $1
       inc %j
     }
     .timersplit 1 3 /netsplit
     halt
  }
  %M = $comchan($1,0) | set %j 1
  while (%j <= %M) {
    %chan = $comchan($1,%j)
    echo 2 %chan $chr(91) $+ $time $+ $chr(93) *** Déconnexion: $1 ( $+ $2 $+ ) $iif($3 != $null,( $+ $3- $+ ))
    inc %j
  }
  halt
} 

; Verrouillage du sujet
Alias TopicLock {
	var %salon = $chan
	if ($1 == ON) { cs set %salon topiclock ON }
	else { cs set %salon topiclock OFF }
}

; Faire parler le bot
Alias BotSay {
   var %salon = $1
   var %message = $2- 
   if (%message !== "") { bs say %salon %message }  
   halt
}

; Faire une action avec le bot
Alias BotAct {
   var %salon = $1
   var %action = $2-
   if (%action !== "") { bs act %salon %message }  
   else { notice $nick Vous n'avez pas défini de message! }
   halt
}

; Activer la symbiose avec le bot
Alias Symbiose {
  var %salon = #
  if ($1 == ON) { bs SET %salon SYMBIOSIS ON }
  else { bs SET %salon SYMBIOSIS OFF }
  halt
}

; Ignorer tout le monde
Alias ignoreAll {
	if ($1 == ON) { ignore *!*@* }
	else { ignore -r *!*@* }
	halt
}

; Commande pour s'enregistrer
Alias regAccount {
    msg nickserv register $2 $emailaddr 
	halt
}

; Rapporter un message
Alias botReport {
   if ($2- != $null) {
      set -u0 %flood [ $+ [ $nick ] ] $true
      msg $chan $+($nick, nous vous remercions pour le rapport !)
   }
   halt
}

;=====================================================
; Script         : Commande Homme / Femme
;=====================================================
Alias homme {
	timer 1 2 
	me est un humain de genre masculin. Très fidèle et très bon compagnon, il est gentil et très docile avec les filles (qu'il respecte infiniment). Il faut en prendre soin et ne pas le vexer. Ni lui faire peur, car il est sensible. Il est carnivore. 
    halt
}

Alias femme {
   timer 1 2 
   me est un humain de genre féminin.
   halt
}

;=====================================================
; Script         : Commande Léchouilles
;=====================================================
Alias lechouille { 
   var %pseudo = $2
   timer 1 2 
   me léchouille 4 $+ $2 $+ 6 dans le cou.
   halt
}

;=====================================================
; Script         : Gestion des nouvelles
;=====================================================
; Afficher la dernière nouvelle
Alias Nouvelle {
   var %salon = $chan
   var %fichier = $shortfn($mircdir\datas\nouvelles.txt)
   var %lignes = $lines(%fichier).text
   ; Afficher la dernière nouvelle
   msg %salon $read(%fichier, %lignes)
}

; Ajouter des nouvelles
Alias AjoutNouvelle {
   var %fichier = $shortfn($mircdir\datas\nouvelles.txt)
   var %message = $1-
   var %temps = $date
   var %pseudo = $nick
   ; Si vous tappez /ajoutnouvelle help un message d'aide s'affichera
   if ($1 == help) { echo 3 * Utilisation: "/ajoutnouvelle <Contenu de la nouvelle>" | return }
   ; Si pas de paramètre, un message d'erreur s'affiche
   if ($1 == $null) { echo 2 * Paramètre insuffisant! | return }
   ; Stocke le texte: "[Date] Contenu de la nouvelle" dans le fichier texte
   write %fichier $chr(91) $+ %temps $+ $chr(93) $+ $chr(160) $+ %message $+ 
   ; Affiche un message d'information
   .notice %pseudo Votre nouvelle a été ajoutée dans la base de données!
}

;=====================================================
; Script         : Moteur DuckDuckGo
;=====================================================


;=====================================================
; Script         : Moteur Google
;=====================================================


;=====================================================
; Script         : Moteur Wikipedia
;=====================================================


;=====================================================
; Script         : Gestion des slogans aléatoires
;=====================================================
Alias Slogan {
   if ($1 == help) { echo 3 * Utilisation: "/slogan <Pseudo>" | return }
   if ($1 == $null) { echo 2 * Paramètre insuffisant! | return }	
   var %fichier = $shortfn($mircdir\datas\slogans.txt)
   var %salon = $chan
   var %pseudo = $1
   var %lecture = $read(%fichier)
   ; Remplace la mention {PSEUDO} par sa valeur
   var $slogan = $replace(%lecture,{PSEUDO},%pseudo)
   
   msg %salon %slogan
}

;=====================================================
; Script         : Gestion des citations
;=====================================================
; Ajouter la citation
Alias AjouterCitation {
   var %fichier = $shortfn($mircdir\datas\citations.txt)
   var %message = $1-
   var %pseudo = $nick
   ; Si vous tappez /ajoutercitation help un message d'aide s'affichera
   if ($1 == help) { echo 3 * Utilisation: "/ajouterCitation <Citation>" | return }
   ; Si pas de paramètre, un message d'erreur s'affiche
   if ($1 == $null) { echo 2 * Paramètre insuffisant! | return }
   ; Stocke le texte: <Pseudo> "Texte" dans le fichier texte
   write %fichier  $chr(60) $+ %pseudo $+ $chr(62) " $+  $+ %message $+ "
   ; Affiche un message d'information
   .notice %pseudo Votre citation a été ajoutée dans la base de données!
}

;=====================================================
; Script         : Système de vote
;=====================================================
; Ajouter un vote
Alias AjoutSondage {
   var %question = $1-
   var %reponses = $2
   var %salon = $chan
   ; Si vous tappez /ajoutsondage help un message d'aide s'affichera
   if ($1 == help) { echo 3 * Utilisation: "/ajoutsondage <Question> <Réponses>" | return }
   ; Si pas de paramètre, un message d'erreur s'affiche
   if ($1 == $null) { echo 2 * Paramètres insuffisants! | return }
   ; Affiche la question et les réponses du vote
   msg %salon Sondage: %question
   msg %salon Vos choix: $gettok(%reponses,$calc($2 - 1),32)
}

; Voter
Alias Vote {
   var %question = $1
   var %reponses = $2
   var %salon = $chan

   ; Affiche un message d'information
   .notice %pseudo Votre vote a été pris en compte!
}

; Affichage des résultats
Alias ResultatsVote {
   var %compteur = 1
}

;=====================================================
; Script         : Actions de modération
;=====================================================
; Expulser un membre
Alias Expulser {
   var %chan = #
   var %user = $1
   var %reason = $2-
   if ($1 == help) { echo 3 * Utilisation: "/expulser <Pseudo> <Raison d'expulsion>" | return }
   cs kick %chan %user %reason
}

; Bannir un membre
Alias Bannnir {
   var %salon = #
   var %utilisateur = $1
   var %raison = $2-
   if ($1 == help) { echo 3 * Utilisation: "/bannnir <Pseudo> <Raison d'expulsion>" | return }
   cs ban %chan %utilisateur %raison
}

; Définir un sujet
Alias Sujet {
  var %salon = #
  if ($1 == help) { echo 3 * Utilisation: "/sujet <Titre du sujet>" | return }
  if (($nick isop %salon) || ($nick ishop %salon)) { msg chanserv topic %salon $1- } 
}

;=====================================================
; Script         : Actions de jeu
;=====================================================
; Fait parler le personnage
Alias Parler {
   if ($1 == help) { echo 3 * Utilisation: "/parler <Texte de parole>" | return }
   msg $chan « $1- »
}

; Jet de dés
Alias Des {
  if ($1 == help) { echo 3 * Utilisation: "/des <Nombre de dés> <Nombre de faces>" | return }
  ; Définition des variables
  var %dices = $1
  var %sides = $2
  var %count 0
  ; Affichage du dé lancé
  msg $chan Vous lancez un dé de %dices $+ D $+ %sides
  ; Boucle
  while (%count < $1) { 
     inc %count 
     msg $chan Résultat du lancer n° $n $+ : $+ $chr(160) $+ $rand(0,%sides) $+ 
  }
}

;=====================================================
; Script         : Quizz
;=====================================================